-- Particle Force Generator class definition File
-- Requires 'particle'

-- Class Definition
pfgen = {list = {}}

-- Class constructor
function pfgen:new(v)
	local fgen = {vector = Vector2d:new(v.x or 0,v.y or 0),}
	self.__index = self
	table.insert(pfgen.list,fgen)
	return setmetatable(fgen,self)
end

-- Connects a Force generator to a specific particle 
function pfgen:connect(p)
	if not self.particle then self.particle = {} end
	table.insert(self.particle,p.id)
	--print(p.id,'particle connected')
end

-- Updates all force generators created
function pfgen:update(t)
	if Particle then
		for i,fgen in ipairs(pfgen.list) do
			if fgen.updateMethod and fgen.particle then
				for _,particle in ipairs(fgen.particle) do
				fgen:updateMethod(particle,t)
				end
			end
		end
	end
end

-- Custom GRAVITY force generator
GRAVITY = pfgen:new {x = 0, y = 0.01}
function GRAVITY:updateMethod(p,t)
	if Particle.list[p]:hasFiniteMass() then
	local f = Vector2d:new(self.vector.x,self.vector.y)
	f:scale(Particle.list[p]:getMass())
	Particle.list[p]:addForce(f)
	end
end






